<?php
/**
 * @package		Gantry Template Framework - RocketTheme
 * @version		${project.version} ${build_date}
 * @author		RocketTheme http://www.rockettheme.com
 * @copyright 	Copyright (C) 2007 - ${copyright_year} RocketTheme, LLC
 * @license		http://www.gnu.org/licenses/gpl-2.0.html GNU/GPLv2 only
 *
 * Gantry uses the Joomla Framework (http://www.joomla.org), a GNU/GPLv2 content management system
 *
 */
defined('JPATH_BASE') or die();

gantry_import('core.gantryfeature');

class GantryFeatureStyleDeclaration extends GantryFeature {
    var $_feature_name = 'styledeclaration';

    function isEnabled() {
        global $gantry;
        $menu_enabled = $this->get('enabled');

        if (1 == (int)$menu_enabled) return true;
        return false;
    }

	function init() {
        global $gantry;

		// tooltips for articledetails layout3
		if ($gantry->get('articledetails') == 'layout3') $gantry->addScript('gantry-articledetails.js');
		
		//inline css for dynamic stuff
		$css = 'body {background:'.$gantry->get('page-background').';}'."\n";
		
		$css .= '#rt-body-background, .roksearch-wrapper {background:'.$gantry->get('body-background').';}'."\n";
		$css .= '#roksearch_results {background-color:'.$gantry->get('body-background').';}'."\n";
		$css .= '.roksearch_odd:hover, .roksearch_even:hover {background:'.$gantry->get('body-background').' !important;}'."\n";
		$css .= '.box5, .title5 .title, #rokmicronews .micronews-list ul li.active a span {color:'.$gantry->get('body-background').';}'."\n";
		$css .= 'body, body a:hover, #rt-bottom {color:'.$gantry->get('body-text').';}'."\n";
		$css .= 'body a {color:'.$gantry->get('body-link').';}'."\n";
		$css .= '.title7 .module-title, #rokmicronews .micronews-headline {border-color:'.$gantry->get('body-text').';}'."\n";
		
		$css .= '#rt-header-surround3, #rt-logoblock, .box7, #rt-header .readon, #rt-navigation .readon, .readonstyle-button .box6 .readon, #newsflash .flashing {background-color:'.$gantry->get('logo-background').';}'."\n";
		$css .= '#rt-subnavigation {border-color:'.$gantry->get('logo-background').';}'."\n";
		$css .= '.title span {color:'.$gantry->get('logo-background').';}'."\n";
		$css .= '#rt-logoblock, #rt-logoblock a:hover, .box7, .box7 a:hover, #newsflash .flashing {color:'.$gantry->get('logo-text').';}'."\n";
		$css .= '#rt-logoblock a, .box7 a, .box7 .title span {color:'.$gantry->get('logo-link').';}'."\n";
		
		$css .= '#rt-header-surround2, #rt-header, #rt-navigation, #rt-footerbar3, #rt-top, .readonstyle-button .readon, .box6, .menutop .fusion-submenu-wrapper {background-color:'.$gantry->get('header-background').';}'."\n";
		$css .= '#rt-header, #rt-navigation, #rt-top, .readonstyle-button .readon, .readonstyle-button .readon .button, #rt-footer .readon, #rt-copyright .readon, .box6, .fusion-submenu-wrapper {color:'.$gantry->get('header-text').';}'."\n";
		$css .= '#rt-header a, #rt-navigation a, #rt-top a, #rt-header .title span, #rt-navigation .title span, #rt-top .title span, .box6 a, .box6 .title span, #rt-subnavigation ul.menu li .item:hover, #rt-subnavigation ul.menu li.active .item, .menutop li .item, .fusion-submenu-wrapper a {color:'.$gantry->get('header-link').';}'."\n";
		
		$css .= '#rt-subnavigation {background-color:'.$gantry->get('submenu-background').';}'."\n";
		$css .= '#rt-subnavigation {color:'.$gantry->get('submenu-text').';}'."\n";
		$css .= '#rt-subnavigation a {color:'.$gantry->get('submenu-link').';}'."\n";
		
		$css .= '#rt-footerbar, .worldmap .location {background-color:'.$gantry->get('footer-background').';}'."\n";
		$css .= '#rt-footer, #rt-copyright, .rt-details-top {color:'.$gantry->get('footer-text').';}'."\n";
		$css .= '#rt-footer a, #rt-footer .item, #rt-copyright a {color:'.$gantry->get('footer-link').';}'."\n";
		
		$css .= '.roknewsflash {background:'.$gantry->get('alert-background').';}'."\n";
		$css .= '.roknewsflash ul li a {color:'.$gantry->get('alert-text').';}'."\n";
		
		/* RokFeaturetable */
		$css .= '.featuretable-col-border .featuretable-cell, .featuretable-col-border .featuretable-head, .featuretable .featuretable-col.highlight .featuretable-cell {background-color:'.$gantry->get('body-background').';}'."\n";
		
		/* RokNewsPager */
		$css .= '.roknewspager .roknewspager-title {border-color:'.$gantry->get('body-text').';}'."\n";
		
		/* RokQuickCart */
		$css .= '.readonstyle-button .cart_product_add .item_add span, .readonstyle-button .simpleCart_checkout span, .readonstyle-button .simpleCart_empty span {color:'.$gantry->get('header-text').';}'."\n";
		$css .= '.cart_totals div {color:'.$gantry->get('body-text').';}'."\n";
		
		/* RokTwittie */
		$css .= '.box1 #roktwittie .title, .box2 #roktwittie .title, .box3 #roktwittie .title, .box4 #roktwittie .title {color:'.$gantry->get('body-text').';border-color:'.$gantry->get('body-text').';}'."\n";
		$css .= '.box5 #roktwittie .title {color:'.$gantry->get('body-background').';border-color:'.$gantry->get('body-background').';}'."\n";
		$css .= '.box6 #roktwittie .title {color:'.$gantry->get('header-link').';border-color:'.$gantry->get('header-link').';}'."\n";
		$css .= '.box7 #roktwittie .title {color:'.$gantry->get('logo-link').';border-color:'.$gantry->get('logo-link').';}'."\n";		

		/* RokWeather */
		$css .= '.box1 #rokweather .degrees .active, .box1 #rokweather .degrees, .box1 #rokweather .day span.low, .box1 #rokweather .day span.high, .box2 #rokweather .degrees .active, .box2 #rokweather .degrees, .box2 #rokweather .day span.low, .box2 #rokweather .day span.high, .box3 #rokweather .degrees .active, .box3 #rokweather .degrees, .box3 #rokweather .day span.low, .box3 #rokweather .day span.high, .box4 #rokweather .degrees .active, .box4 #rokweather .degrees, .box4 #rokweather .day span.low, .box4 #rokweather .day span.high {color:'.$gantry->get('body-text').';border-color:'.$gantry->get('body-text').';}'."\n";
		$css .= '.box5 #rokweather .degrees .active, .box5 #rokweather .degrees, .box5 #rokweather .day span.low, .box5 #rokweather .day span.high {color:'.$gantry->get('body-background').';border-color:'.$gantry->get('body-background').';}'."\n";
		$css .= '.box6 #rokweather .degrees .active, .box6 #rokweather .degrees, .box6 #rokweather .day span.low, .box6 #rokweather .day span.high {color:'.$gantry->get('header-link').';border-color:'.$gantry->get('header-link').';}'."\n";
		$css .= '.box7 #rokweather .degrees .active, .box7 #rokweather .degrees, .box7 #rokweather .day span.low, .box7 #rokweather .day span.high {color:'.$gantry->get('logo-link').';border-color:'.$gantry->get('logo-link').';}'."\n";
		
		if ($gantry->get('iphone-enabled')) {
			$css .= 'body.rt-normal .rt-articleinfo, body.rt-flipped .rt-articleinfo, body.rt-left .rt-articleinfo, body.rt-right .rt-articleinfo {color:'.$gantry->get('body-link').';}'."\n";
		}

		if ($gantry->get('thirdparty')){
			
			// JomSocial
			$css .= 'body #community-wrap div.greybox .joinbutton #joinButton, body #rt-main #community-wrap .loginform #form-login #submit, body #rt-main #community-wrap .loginform #form-login #submit:hover, body #community-wrap .button {background-color:'.$gantry->get('header-background').';}'."\n";
			$css .= 'body #community-wrap div.greybox .joinbutton #joinButton, body #rt-main #community-wrap .loginform #form-login #submit, body #community-wrap .button {color:'.$gantry->get('header-text').';}'."\n";
			$css .= 'body #community-wrap .introduction h1, #community-wrap .app-box-title, #community-wrap .cModule h3, body #community-wrap .video-item .video-itembody, body #community-wrap .profile-avatar img, body #community-wrap div#profile-status, #community-wrap .app-item, #community-wrap ul.submenu li a {border-color:'.$gantry->get('body-text').';}'."\n";
			$css .= '#community-wrap .app-box-title {color:'.$gantry->get('body-text').' !important;}'."\n";
			$css .= 'body #community-wrap #cToolbarNav.cToolbar, body #community-wrap #cToolbarNav.cToolbar #cToolbar_inner {background: none '.$gantry->get('header-background').' !important;}'."\n";
			$css .= '#community-wrap #cToolbarNav.cToolbar ul#cToolbarNavList li.toolbar-active div a, #community-wrap #cToolbarNav.cToolbar ul#cToolbarNavList li div a, #community-wrap #cToolbarNav.cToolbar ul#cToolbarNavList li.toolbar-active div a:hover, #community-wrap #cToolbarNav.cToolbar ul#cToolbarNavList li div a:hover {background-color:'.$gantry->get('submenu-background').' !important;}'."\n";
			$css .= '#community-wrap #cToolbarNav.cToolbar ul#cToolbarNavList div a.has-separator, #community-wrap #cToolbarNav.cToolbar ul#cToolbarNavList li.toolbar-active div a, #community-wrap #cToolbarNav.cToolbar ul#cToolbarNavList li.toolbar-active div a.has-separator {border-color:'.$gantry->get('body-text').' !important;}'."\n";
			$css .= '#community-wrap .cToolbar#cToolbarNav ul#cToolbarNavList li#toolbar-item-logout, #community-wrap .cToolbar#cToolbarNav ul#cToolbarNavList li#toolbar-item-logout a {color:'.$gantry->get('header-text').' !important;}'."\n";
			$css .= '#community-wrap ul.submenu li a, #community-wrap ul.submenu li span {color:'.$gantry->get('body-text').' !important;}'."\n";
			
			// K2
			$css .= '#k2Container .subCategory, #k2Container .itemListCategory, #k2Container .catItemHeader .catItemTitle, #k2Container .itemImageBlock img, #k2Container .catItemHeader .catItemTitle, #k2Container .itemListSubCategories h3, #k2Container .catItemImage img, #k2Container .itemDateModified, #k2Container .itemHeader .itemTitle, #k2Container .itemCommentsForm .itemCommentsFormNotes, #k2Container .userItemImage img {border-color:'.$gantry->get('body-text').';}'."\n";
			$css .= '#k2Container .itemCommentsForm .button {background-color:'.$gantry->get('header-background').';}'."\n";
			$css .= '#k2Container .itemCommentsForm .button {color:'.$gantry->get('header-text').';}'."\n";
			
			//Tienda
			$css .= 'div#tienda_category_header, div#tienda_subcategories, #tienda #tienda_product_header {border-color:'.$gantry->get('body-text').';}'."\n";
			
			// Virtuemart
			$css .= '#vmMainPage h1, #vmMainPage .vmCartContainer, #vmMainPage h3 {border-color:'.$gantry->get('body-text').';}'."\n";
			
			// JComments
			$css .= '#comments-form .btn a, #comments-report-form .btn a, body #community-wrap div.greybox .joinbutton a#joinButton:hover {background-color:'.$gantry->get('header-background').';}'."\n";
			$css .= '#comments-form .btn a, #comments-report-form .btn a, #comments-form .btn a:hover, #comments-report-form .btn a:hover, body #community-wrap div.greybox .joinbutton a#joinButton:hover {color:'.$gantry->get('header-text').';}'."\n";
			
			//Contact Form Enhanced
			$css .= '#ce-form-container .button {background-color:'.$gantry->get('header-background').';}'."\n";
			$css .= '#ce-form-container .button {color:'.$gantry->get('header-text').';}'."\n";
		}

		//ie6 specific style
		if ($gantry->browser->name == 'ie' && $gantry->browser->shortversion == '6') {
			$css .= '#rt-navigation .menutop li ul {background-color:'.$gantry->get('submenu-background').';}'."\n";
			$css .= '#rt-navigation .menutop li ul li a, #rt-navigation .menutop li ul li span {color:'.$gantry->get('submenu-text').';}'."\n";
		}

		if ($gantry->get('static-enabled')) {
            // do file stuff
            jimport('joomla.filesystem.file');
            $filename = $gantry->templatePath.DS.'css'.DS.'static-styles.css';

            if (file_exists($filename)) {
                if ($gantry->get('static-check')) {
                    //check to see if it's outdated

                    $md5_static = md5_file($filename);
                    $md5_inline = md5($css);

                    if ($md5_static != $md5_inline) {
                        JFile::write($filename, $css);
                    }
                }
            } else {
                // file missing, save it
                JFile::write($filename, $css);
            }
            // add reference to static file
            $gantry->addStyle('static-styles.css',99);

        } else {
            // add inline style
            $gantry->addInlineStyle($css);
        }


		$this->_disableRokBoxForiPhone();

		//style stuff
        //$gantry->addStyle($gantry->get('cssstyle').".css");
		if ($gantry->get('thirdparty')) $gantry->addStyle('extended.css');

	}

	function _disableRokBoxForiPhone() {
		global $gantry;

		if ($gantry->browser->platform == 'iphone') {
			$gantry->addInlineScript("window.addEvent('domready', function() {\$\$('a[rel^=rokbox]').removeEvents('click');});");
		}
	}

}